import requests
import json
import random
import time
import sqlite3
import telegram
from datetime import datetime
import os
from pytube import YouTube  # برای دانلود ویدیو از یوتیوب

# توکن بوت تلگرام خود را اینجا قرار دهید
bot_token = '6761881709:AAFYDLL_FnbmLOUViqwQVIIxjTraYr1MJE4'
channel_username = '@imdbpopcorn'

# اتصال به API و دریافت اطلاعات فیلم
API_KEY = '9980dc61324a7df9eea48a3f9af2feb9'
MOVIE_API_URL = 'https://api.themoviedb.org/3/movie/popular'
MOVIE_TRAILER_URL = 'https://api.themoviedb.org/3/movie/{}/videos'

bot = telegram.Bot(token=bot_token)

# اتصال به دیتابیس SQLite برای پیگیری فیلم‌های ارسال شده
conn = sqlite3.connect('posted_movies.db')
cursor = conn.cursor()
cursor.execute('''CREATE TABLE IF NOT EXISTS posted_movies (movie_id INTEGER PRIMARY KEY, posted_at TEXT)''')
conn.commit()

# دریافت فیلم‌های محبوب از API
def get_popular_movies():
    response = requests.get(MOVIE_API_URL, params={'api_key': API_KEY, 'language': 'fa-IR', 'page': 1})
    movies = response.json().get('results', [])
    return movies

# دریافت تریلر برای فیلم
def get_trailer(movie_id):
    trailer_url = MOVIE_TRAILER_URL.format(movie_id)
    response = requests.get(trailer_url, params={'api_key': API_KEY, 'language': 'fa-IR'})
    trailers = response.json().get('results', [])
    if trailers:
        trailer_key = trailers[0].get('key')
        return f'https://www.youtube.com/watch?v={trailer_key}'
    return None

# دانلود تریلر از یوتیوب
def download_trailer(trailer_url, movie_title):
    try:
        yt = YouTube(trailer_url)
        stream = yt.streams.filter(progressive=True, file_extension='mp4').first()
        download_path = f"downloads/{movie_title}_trailer.mp4"
        stream.download(output_path="downloads", filename=f"{movie_title}_trailer.mp4")
        return download_path
    except Exception as e:
        print(f"خطا در دانلود تریلر: {e}")
        return None

# ارسال پیام به کانال تلگرام
def send_message_to_channel(bot, movie):
    # بررسی اینکه این فیلم قبلاً ارسال شده یا نه
    cursor.execute("SELECT * FROM posted_movies WHERE movie_id = ?", (movie['id'],))
    if cursor.fetchone():
        print(f"فیلم {movie['title']} قبلاً ارسال شده است.")
        return

    # دریافت تریلر
    trailer_url = get_trailer(movie['id'])
    if not trailer_url:
        print(f"تریلر برای فیلم {movie['title']} پیدا نشد.")
        return

    # دانلود تریلر
    download_path = download_trailer(trailer_url, movie['title'])
    if not download_path:
        print(f"خطا در دانلود تریلر فیلم {movie['title']}.")
        return

    # ژانرهای فیلم
    genres = ", ".join([genre['name'] for genre in movie.get('genres', [])])

    # آماده‌سازی پیام
    release_date = movie.get('release_date', 'N/A')
    movie_info = f"""
    🎬 *{movie['title']}*  
    📅 تاریخ اکران: {release_date}  
    🎥 تریلر: {trailer_url}  
    🏷️ ژانر: {genres}  
    📜 توضیحات: {movie['overview']}
    """

    # ارسال تصویر و تریلر به کانال
    try:
        # ارسال عکس و لینک تریلر
        bot.send_photo(chat_id=channel_username, photo=f'https://image.tmdb.org/t/p/w500{movie["poster_path"]}', caption=movie_info)
        # ارسال تریلر دانلود شده
        bot.send_video(chat_id=channel_username, video=open(download_path, 'rb'), caption="تریلر فیلم")
        print(f"فیلم {movie['title']} ارسال شد.")

        # ذخیره اطلاعات فیلم برای جلوگیری از ارسال مجدد
        cursor.execute("INSERT INTO posted_movies (movie_id, posted_at) VALUES (?, ?)", (movie['id'], datetime.now()))
        conn.commit()
        
    except Exception as e:
        print(f"خطا در ارسال فیلم: {e}")

# ارسال فیلم‌های محبوب به کانال
def send_popular_movies():
    movies = get_popular_movies()
    for movie in movies:
        send_message_to_channel(bot, movie)
        time.sleep(10)  # جلوگیری از ارسال درخواست‌های متوالی سریع

# اجرای برنامه
if __name__ == '__main__':
    # ایجاد پوشه برای ذخیره فایل‌های دانلود شده در صورت عدم وجود
    if not os.path.exists('downloads'):
        os.makedirs('downloads')

    send_popular_movies()

